#ifndef __AUDIO
#define __AUDIO

#include "console.h"
#include <iostream>
using namespace std;

struct audio_out {
	
	static const int NUM_CHANNELS = 2;
	static const int SAMPLES_PER_CHANNEL = 32;
	static const int SAMPLES_PER_BUFFER = NUM_CHANNELS * SAMPLES_PER_CHANNEL;
	short ibuf [SAMPLES_PER_BUFFER]; // oss
	float fbuf [SAMPLES_PER_BUFFER]; // din
	
	static const int IBUFFER_SIZE = sizeof (short) * SAMPLES_PER_BUFFER;
	static const int FBUFFER_SIZE = sizeof (float) * SAMPLES_PER_BUFFER;
	static const short MAX_SHORT = 32767;
	
	string prefs_name;
	
	string dsp_name;
	int sample_format;
	int num_channels;
	int sample_rate;
	int fragment_power;
	int fragment_select;
	
	int fd;
	
	pthread_t tid;
	int playing;
	
	audio_out ();
	void load_prefs ();
	void defaults ();
	
	~audio_out ();
	void save_prefs ();

	int open ();
	int close ();

	int start ();
	int stop ();
	
	void write ();

};

void* audio_wanted (void*);
console& operator<< (console& c, const audio_out& ao);

#endif
