#include "din.h"

string APP_NAME;
int SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_DEPTH;
int SAMPLE_RATE;
string INTERVALS_FILE;
map <char, float> INTERVALS;
map <char, int> NOTE_POS;
int NUM_INTERVALS;
char FIRST_INTERVAL_NAME, LAST_INTERVAL_NAME;
int NUM_VOLUMES, LAST_VOLUME;
float DELTA_VOLUME;
string RAGA;
int NUM_MICROTONES;
int MAX_HEIGHT = din::MAX_VOLUMES - 1;
int LEFT, BOTTOM, RIGHT, TOP, HEIGHT;

bool load_globals::load_intervals (const string& fname) {
	
	extern string dotdin;
	ifstream file ((dotdin + fname).c_str(), ios::in);
	if (file) {
		
		file >> ignore >> NUM_INTERVALS;
		for (int i = 0, last = NUM_INTERVALS - 1, pos = 0; i < NUM_INTERVALS; ++i) {

			char note_name;
			float value;

			file >> note_name >> value;
											
			if (i == 0) FIRST_INTERVAL_NAME = note_name; 
			else if (i == last) LAST_INTERVAL_NAME = note_name;
			
			INTERVALS [note_name] = value;
			NOTE_POS [note_name] = pos++;

		}
		
		return true;
		

	} else return false;

}

load_globals::load_globals () {
	extern string dotdin;
	ifstream file ((dotdin + "globals").c_str(), ios::in);
	if (file) {
		cout << "loading globals..." << endl;
		file >> ignore >> APP_NAME;
		file >> ignore >> SCREEN_WIDTH >> SCREEN_HEIGHT >> SCREEN_DEPTH;
		file >> ignore >> INTERVALS_FILE;
		file >> ignore >> RAGA;
		file >> ignore >> LEFT >> BOTTOM;
		file >> ignore >> HEIGHT;
		file >> ignore >> NUM_MICROTONES;
		cout << "globals file loaded." << endl;
	} else {
		cout << "bad globals file, will use defaults " << endl;
		APP_NAME = "din";
		SCREEN_WIDTH = 640; SCREEN_HEIGHT = 480;
		INTERVALS_FILE = "pytha";
		RAGA = "bhairav";
		LEFT = 0; BOTTOM = 150; HEIGHT = 300; 
		NUM_MICROTONES = 150; 
	}
	
	load_intervals (INTERVALS_FILE);
	TOP = BOTTOM + HEIGHT;
	calc_volume_vars (min (HEIGHT, MAX_HEIGHT));
	
}

void calc_volume_vars (int h) {
	NUM_VOLUMES = h;
	DELTA_VOLUME = 1./NUM_VOLUMES;
	LAST_VOLUME = NUM_VOLUMES - 1;
}
